/*
 * Copyright (c) 2021-2021, Huawei Technologies Co., Ltd. All rights reserved.
 * Copyright (c) 2020-2021 Huawei Device Co., Ltd. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this list of
 * conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list
 * of conditions and the following disclaimer in the documentation and/or other materials
 * provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its contributors may be used
 * to endorse or promote products derived from this software without specific prior written
 * permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "lt_net_netdb.h"
// 引入头文件，可能包含了网络数据库相关的函数声明和宏定义。

static int GetServEntTest(void)
{
    char serv_file[] = "tcpmux		1/tcp    # TCP port service multiplexer\n"
                       "echo		7/tcp\n"
                       "echo		7/udp\n"
                       "discard		9/tcp		sink null\n"
                       "ssh         100000/tcp\n"
                       "ssh         /tcp\n"
                       "ssh         22/";
    // 定义一个模拟的services文件内容，包含多个服务的条目。
    char *pathList[] = {"/etc/services"};
    // 定义services文件的路径列表，这里只有一个路径指向系统的services文件。
    char *streamList[] = {static_cast<char *>(serv_file)};
    // 定义模拟的services文件流列表，这里将模拟的services文件内容转换为char*类型。
    int streamLen[] = {sizeof(serv_file)};
    // 定义模拟的services文件流长度列表。
    const int file_number = 1;
    // 定义文件数量。
    int flag = PrepareFileEnv(pathList, streamList, streamLen, file_number);
    // 调用PrepareFileEnv函数准备文件环境，模拟services文件。
    if (flag != 0) {
        RecoveryFileEnv(pathList, file_number);
        return -1;
    }
    // 如果准备文件环境失败，则恢复原始文件环境并返回错误码。
    
    /* tcpmux,echo,discard port number is 1,7,9 */
    const int tcpmux_port_no  = 1;
    const int echo_port_no    = 7;
    const int discard_port_no = 9;

    struct servent *se1 = nullptr;
    struct servent *se2 = nullptr;
    struct servent *se3 = nullptr;

    se1 = getservent();
    // 调用getservent函数获取services数据库中的第一个服务条目。
    ICUNIT_ASSERT_NOT_EQUAL(se1, nullptr, -1);
    // 断言se1不为空，即getservent成功。
    ICUNIT_ASSERT_STRING_EQUAL(se1->s_name, "tcpmux", -1);
    // 断言返回的服务名称与"tcpmux"相同。
    ICUNIT_ASSERT_STRING_EQUAL(se1->s_proto, "tcp", -1);
    // 断言返回的服务协议与"tcp"相同。
    ICUNIT_ASSERT_EQUAL(se1->s_port, ntohs(tcpmux_port_no), -1);
    // 断言返回的服务端口号与转换为网络字节序的1相同。

    endservent();
    // 调用endservent函数结束服务数据库的搜索。
    se2 = getservent();
    // 再次调用getservent函数获取services数据库中的第一个服务条目。
    ICUNIT_ASSERT_NOT_EQUAL(se2, nullptr, -1);
    // 断言se2不为空，即getservent成功。
    ICUNIT_ASSERT_STRING_EQUAL(se1->s_name, se2->s_name, -1);
    // 断言返回的服务名称与之前相同。
    ICUNIT_ASSERT_STRING_EQUAL(se1->s_proto, se2->s_proto, -1);
    // 断言返回的服务协议与之前相同。
    ICUNIT_ASSERT_EQUAL(se1->s_port, se2->s_port, -1);
    // 断言返回的服务端口号与之前相同。

    setservent(0);
    // 调用setservent函数设置服务数据库的搜索位置到开始。
    se3 = getservent();
    // 调用getservent函数获取services数据库中的第一个服务条目。
    ICUNIT_ASSERT_NOT_EQUAL(se3, nullptr, -1);
    // 断言se3不为空，即getservent成功。
    ICUNIT_ASSERT_STRING_EQUAL(se1->s_name, se3->s_name, -1);
    // 断言返回的服务名称与之前相同。
    ICUNIT_ASSERT_STRING_EQUAL(se1->s_proto, se3->s_proto, -1);
    // 断言返回的服务协议与之前相同。
    ICUNIT_ASSERT_EQUAL(se1->s_port, se3->s_port, -1);
    // 断言返回的服务端口号与之前相同。

    se3 = getservent();
    // 获取下一个服务条目。
    ICUNIT_ASSERT_NOT_EQUAL(se3, nullptr, -1);
    // 断言se3不为空，即getservent成功。
    ICUNIT_ASSERT_STRING_EQUAL(se3->s_name, "echo", -1);
    // 断言返回的服务名称与"echo"相同。
    ICUNIT_ASSERT_STRING_EQUAL(se3->s_proto, "tcp", -1);
    // 断言返回的服务协议与"tcp"相同。
    ICUNIT_ASSERT_EQUAL(se3->s_port, ntohs(echo_port_no), -1);
    // 断言返回的服务端口号与转换为网络字节序的7相同。

    se3 = getservent();
    // 获取下一个服务条目。
    ICUNIT_ASSERT_NOT_EQUAL(se3, nullptr, -1);
    // 断言se3不为空，即getservent成功。
    ICUNIT_ASSERT_STRING_EQUAL(se3->s_name, "echo", -1);
    // 断言返回的服务名称与"echo"相同。
    ICUNIT_ASSERT_STRING_EQUAL(se3->s_proto, "udp", -1);
    // 断言返回的服务协议与"udp"相同。
    ICUNIT_ASSERT_EQUAL(se3->s_port, ntohs(echo_port_no), -1);
    // 断言返回的服务端口号与转换为网络字节序的7相同。

    se3 = getservent();
    // 获取下一个服务条目。
    ICUNIT_ASSERT_NOT_EQUAL(se3, nullptr, -1);
    // 断言se3不为空，即getservent成功。
    ICUNIT_ASSERT_STRING_EQUAL(se3->s_name, "discard", -1);
    // 断言返回的服务名称与"discard"相同。
    ICUNIT_ASSERT_STRING_EQUAL(se3->s_proto, "tcp", -1);
    // 断言返回的服务协议与"tcp"相同。
    ICUNIT_ASSERT_EQUAL(se3->s_port, ntohs(discard_port_no), -1);
    // 断言返回的服务端口号与转换为网络字节序的9相同。
    ICUNIT_ASSERT_STRING_EQUAL(se3->s_aliases[0], "sink", -1);
    // 断言返回的服务别名列表中的第一个别名与"sink"相同。
    ICUNIT_ASSERT_STRING_EQUAL(se3->s_aliases[1], "null", -1);
    // 断言返回的服务别名列表中的第二个别名与"null"相同。
    ICUNIT_ASSERT_EQUAL(se3->s_aliases[2], nullptr, -1);
    // 断言返回的服务别名列表中的第三个别名为nullptr，表示别名列表结束。

    se3 = getservent();
    // 获取下一个服务条目。
    ICUNIT_ASSERT_EQUAL(se3, nullptr, -1);
    // 断言se3为空，即已经到达services数据库的末尾。
    endservent();
    // 调用endservent函数结束服务数据库的搜索。
    
    RecoveryFileEnv(pathList, file_number);
    // 恢复原始文件环境。
    return ICUNIT_SUCCESS;
    // 返回测试成功。
}

void NetNetDbTest018(void)
{
    TEST_ADD_CASE(__FUNCTION__, GetServEntTest, TEST_POSIX, TEST_TCP, TEST_LEVEL0, TEST_FUNCTION);
}
// 定义测试用例，将GetServEntTest函数注册为一个测试案例。